/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATmega88+ATA6824 
** Pʕ	: High_temp_H-bridge_board.h 
** 		: "Hد ъ"ŎgI/Oϸ
**
**  :  		  t: : :
** 1.0   2007N123  F.G.  쐬

**
**
**
** LICENSE - 
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/

#ifndef _BOARD_H
#define _BOARD_H

/*_____ ` ____________________________________________________________*/


//-----------------------------------------------------------------------//
//                               MCU߰Đ錾                             //
//-----------------------------------------------------------------------//


//PORTB
#define _DG3_LED			0x01	// PB0(ICP1/CLKO/PCINT0)
#define _DG2_LED			0x02	// PB1(OC1A/PCINT1)
#define _DG1_LED			0x04	// PB2(OC1B/SS/PCINT2)
#define _MOSI				0x08	// PB3(MOSI/OC2A/PCINT3)
#define _MISO				0x10	// PB4(MISO/PCINT4)
#define _SCK				0x20	// PB5(SCK/PCINT5)
#define _HALL2_S			0x40	// PB6(TOSC1/XTALL1/PCINT6)
#define _HALL1_S			0x80	// PB7(TOSC2/XTAL2/PCINT7)

//PORTC
#define _V_SHUNT			0x01	// PC0(ADC0/PCINT8)
#define _RELEASE_BP			0x02	// PC1(ADC1/PCINT9)
#define _DIAG1				0x04	// PC2(ADC2/PCINT10)
#define _DIAG2				0x08	// PC3(ADC3/PCINT11)
#define _DIAG3				0x10	// PC4(ADC4/SDA/PCINT12)
#define _MOTOR_DIR			0x20	// PC5(ADC5/SCL/PCINT13)
#define _NRESET				0x40	// PC6(RESET/PCINT14)

//PORTD
#define _SIO_RXD			0x01	// PD0(RXD/PCINT16)
#define _SIO_TXD			0x02	// PD1(TXD/PCINT17)
#define _WD_TRIG			0x04	// PD2(INT0/PCINT18)
#define _SWITCH_CCW			0x08	// PD3(INT1/OC2B/PCINT19)
#define _SWITCH_CW			0x10	// PD4(T0/XCK/PCINT20)
#define _MOTOR_PWM			0x20	// PD5(T1/OC0B/PCINT21)
#define _V_PROTECT			0x40	// PD6(AIN0/OC0A/PCINT22) 
#define _V_SHUNT_P			0x80	// PD7(AIN1/PCINT2)

//----------------------------------------------------------------------//
//                        MCU苖/֎~ϸ                           //
//----------------------------------------------------------------------//


//----------------------------------------------------------------------//
//                         MCU߰č\ݒϸ                           //
//----------------------------------------------------------------------//

#define  CONFIG_PORTB() (PORTB =  _DG3_LED | _DG2_LED | _DG1_LED, DDRB   = _DG3_LED | _DG2_LED | _DG1_LED)
#define  CONFIG_PORTC() (DDRC   = _MOTOR_DIR,  PORTC  = _RELEASE_BP)
#define  CONFIG_PORTD() (DDRD   = _SIO_TXD | _WD_TRIG | _MOTOR_PWM , PORTD  = _SIO_TXD | _SIO_RXD | _SWITCH_CCW | _SWITCH_CW)

#define  CONFIG_IO_PORTS() (CONFIG_PORTB(),CONFIG_PORTC() ,CONFIG_PORTD())

//----------------------------------------------------------------------//
//                        MCUo͗Llݒϸ                          //
//----------------------------------------------------------------------//
#define SET_DG1_LED()			(PORTB  &=  ~_DG1_LED )
#define SET_DG2_LED()			(PORTB  &=  ~_DG2_LED )
#define SET_DG3_LED()			(PORTB  &=  ~_DG3_LED )
#define SET_MOTOR_DIR()			(PORTC  |=   _MOTOR_DIR)
#define SET_WD_TRIG()			(PORTD  |=   _WD_TRIG)

//----------------------------------------------------------------------//
//                        MCUo͖lݒϸ                          //
//----------------------------------------------------------------------//
#define RESET_DG1_LED()			(PORTB  |=  _DG1_LED  )
#define RESET_DG2_LED()			(PORTB  |=  _DG2_LED  )
#define RESET_DG3_LED()			(PORTB  |=  _DG3_LED  )
#define RESET_MOTOR_DIR()		(PORTC  &= ~_MOTOR_DIR)
#define RESET_WD_TRIG()			(PORTD  &= ~_WD_TRIG  )

//----------------------------------------------------------------------//
//                         MCUo͌ݐؑϸ                           //
//----------------------------------------------------------------------//
#define TOGGLE_DG1_LED()		(PORTB ^= _DG1_LED )
#define TOGGLE_DG2_LED()		(PORTB ^= _DG2_LED )
#define TOGGLE_DG3_LED()		(PORTB ^= _DG3_LED )
#define TOGGLE_WD_TRIG()		(PORTD ^= _WD_TRIG )

//----------------------------------------------------------------------//
//                             MCU擾ϸ                               //
//----------------------------------------------------------------------//
#define GET_SWITCH_CW()			((PIND & _SWITCH_CW) == 0x00)
#define GET_SWITCH_CCW()		((PIND & _SWITCH_CCW) == 0x00)
#define GET_RELEASE_BP()		((PINC & _RELEASE_BP) == 0x00)
#define GET_DG1_STATUS()		((PINC & _DIAG1) == _DIAG1)
#define GET_DG2_STATUS()		((PINC & _DIAG2) == _DIAG2)
#define GET_DG3_STATUS()		((PINC & _DIAG3) == _DIAG3)

//----------------------------------------------------------------------//
//                     MCUްނ܂͎wߊ֘Aϸ                      //
//----------------------------------------------------------------------//

#endif  /* _BOARD_H */
